﻿using Demo.Data.Repository;
using Demo.domain.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Zurnal.Date.Repository;

namespace Demo.Domain.UseCase
{
    public class UserUseCase
    {
        private UserRepositoryImpl _repositoryUserImpl;
        private readonly IGroupRepository _repositoryGroupImpl;

        internal IGroupRepository RepositoryGroupImpl => _repositoryGroupImpl;

        public UserUseCase(UserRepositoryImpl repositoryImpl, GroupRepositoryImpl repositoryGroupImpl)
        {
            _repositoryUserImpl = repositoryImpl;
            _repositoryGroupImpl = (IGroupRepository?)repositoryGroupImpl;
        }

      public List<Group> GetAllGroups() => RepositoryGroupImpl.GetAllGroup()
            .Select(it => new Group { Id  = it.Id, Name = it.Name}).ToList();
      public List<User> GetAllUsers() => _repositoryUserImpl.GetAllUsers
            .Join(RepositoryGroupImpl.GetAllGroup(),
            user => user.GroupID,
            group => group.Id,
            (user, group) => 
            new User { FIO = user.FIO, 
                Guid = user.Guid, 
                Group = new Group {Id = group.Id, Name = group.Name } }
          ).ToList();

        public bool RemoveUserByGuid(Guid userGuid) {
           return _repositoryUserImpl.RemoveUserByGuid(userGuid);
        }
        public User UpdateUser(User user) {
    UserLocalEnity userLocalEnity = new UserLocalEnity { FIO = user.FIO, GroupID = user.Group.Id, Guid = user.Guid };
    UserLocalEnity? result = _repositoryUserImpl.UpdateUser(userLocalEnity);
            if (result == null) throw new Exception("");
            Group? group = GetAllGroups().FirstOrDefault(it => it.Id == result!.GroupID);
    if (group == null) throw new Exception("Группа не найдена");
    return new User { FIO = user.FIO, Guid = user.Guid, Group = group };
}

            public User FindUserByGuid(Guid userGuid)
            {
                var user = _repositoryUserImpl.GetAllUsersList().FirstOrDefault(u => u.Guid == userGuid);
                if (user == null) throw new Exception("Нет такого пользователя");
                var group = RepositoryGroupImpl.GetAllGroup().FirstOrDefault(g => g.Id == user.GroupID);
                return new User { FIO = user.FIO, Guid = user.Guid, Group = group };
            }
        }
    }